import numpy as np
import fc_bench
from fc_bench.bench import bData,line_text_delimiter

def linsolve_diag(N,d,m,verbose=0,**kwargs):
  """ 
  from fc_linalg3D import valids
  valids.linsolve_diag(10000,3,4,1,rtype='array2d')
  valids.linsolve_diag(10000,3,4,1,rtype='array3d')
  valids.linsolve_diag(10000,3,1,1,rtype='array2d')
  valids.linsolve_diag(10000,3,1,1,rtype='array3d')
  """
  from fc_linalg3D.benchs import set_linsolve_diag
  from fc_linalg3D.solver import linsolve_diag_Cpt,linsolve_diag_Mat,linsolve_diag_Vec
  from fc_linalg3D import mtimes,aXpbY
  ltd=line_text_delimiter()
  print(ltd)
  print('# Validation: Functions linsolve_diag_*')
  (A,B,Err),Bd=set_linsolve_diag(N,verbose,d=d,m=m,**kwargs)
  print(ltd)
  print('*** Test linsolve_diag_Cpt function [ref]')
  Xref=linsolve_diag_Cpt(A,B)
  D=aXpbY(1,mtimes(A,Xref),-1,B)
  print('  -> Error |A*X-B|    : %.4e'%np.max(np.abs(D)))
  print('*** Test linsolve_diag_Mat function')
  X=linsolve_diag_Mat(A,B)
  print('  -> Error with [ref] : %.4e'%np.max(np.abs(X-Xref)))
  D=aXpbY(1,mtimes(A,X),-1,B)
  print('  -> Error |A*X-B|    : %.4e'%np.max(np.abs(D)))
  print('*** Test linsolve_diag_Vec function')
  X=linsolve_diag_Vec(A,B)
  print('  -> Error with [ref] : %.4e'%np.max(np.abs(X-Xref)))
  D=aXpbY(1,mtimes(A,X),-1,B)
  print('  -> Error |A*X-B|    : %.4e'%np.max(np.abs(D)))
  
def linsolve_tril(N,d,m,verbose=0,**kwargs):
  """ 
  from fc_linalg3D import valids
  valids.linsolve_tril(10000,3,4,1,rtype='array2d')
  valids.linsolve_tril(10000,3,4,1,rtype='array3d')
  valids.linsolve_tril(10000,3,1,1,rtype='array2d')
  valids.linsolve_tril(10000,3,1,1,rtype='array3d')
  """
  from fc_linalg3D.benchs import set_linsolve_tril
  from fc_linalg3D.solver import linsolve_tril_Cpt,linsolve_tril_Mat,linsolve_tril_Vec
  from fc_linalg3D import mtimes,aXpbY
  ltd=line_text_delimiter()
  print(ltd)
  print('# Validation: Functions linsolve_diag_*')
  (A,B,Err),Bd=set_linsolve_tril(N,verbose,d=d,m=m,**kwargs)
  print(ltd)
  print('*** Test linsolve_tril_Cpt function [ref]')
  Xref=linsolve_tril_Cpt(A,B)
  D=aXpbY(1,mtimes(A,Xref),-1,B)
  print('  -> Error |A*X-B|    : %.4e'%np.max(np.abs(D)))
  print('*** Test linsolve_tril_Mat function')
  X=linsolve_tril_Mat(A,B)
  print('  -> Error with [ref] : %.4e'%np.max(np.abs(X-Xref)))
  D=aXpbY(1,mtimes(A,X),-1,B)
  print('  -> Error |A*X-B|    : %.4e'%np.max(np.abs(D)))
  print('*** Test linsolve_tril_Vec function')
  X=linsolve_tril_Vec(A,B)
  print('  -> Error with [ref] : %.4e'%np.max(np.abs(X-Xref)))
  D=aXpbY(1,mtimes(A,X),-1,B)
  print('  -> Error |A*X-B|    : %.4e'%np.max(np.abs(D)))  
  
def linsolve_triu(N,d,m,verbose=0,**kwargs):
  """ 
  from fc_linalg3D import valids
  valids.linsolve_triu(10000,3,4,1,rtype='array2d')
  valids.linsolve_triu(10000,3,4,1,rtype='array3d')
  valids.linsolve_triu(10000,3,1,1,rtype='array2d')
  valids.linsolve_triu(10000,3,1,1,rtype='array3d')
  """
  from fc_linalg3D.benchs import set_linsolve_triu
  from fc_linalg3D.solver import linsolve_triu_Cpt,linsolve_triu_Mat,linsolve_triu_Vec
  from fc_linalg3D import mtimes,aXpbY
  ltd=line_text_delimiter()
  print(ltd)
  print('# Validation: Functions linsolve_diag_*')
  (A,B,Err),Bd=set_linsolve_triu(N,verbose,d=d,m=m,**kwargs)
  print(ltd)
  print('*** Test linsolve_triu_Cpt function [ref]')
  Xref=linsolve_triu_Cpt(A,B)
  D=aXpbY(1,mtimes(A,Xref),-1,B)
  print('  -> Error |A*X-B|    : %.4e'%np.max(np.abs(D)))
  print('*** Test linsolve_triu_Mat function')
  X=linsolve_triu_Mat(A,B)
  print('  -> Error with [ref] : %.4e'%np.max(np.abs(X-Xref)))
  D=aXpbY(1,mtimes(A,X),-1,B)
  print('  -> Error |A*X-B|    : %.4e'%np.max(np.abs(D)))
  print('*** Test linsolve_triu_Vec function')
  X=linsolve_triu_Vec(A,B)
  print('  -> Error with [ref] : %.4e'%np.max(np.abs(X-Xref)))
  D=aXpbY(1,mtimes(A,X),-1,B)
  print('  -> Error |A*X-B|    : %.4e'%np.max(np.abs(D))) 
  
def linsolve_error(A,X,B):
  return np.max(np.abs(aXpbY(1,mtimes(A,X),-1,B)))
  
def PALU(N,d,fun_PALU): 
  """
  from fc_linalg3D import valids
  from fc_linalg3D.fact import PALU_Mat,PALU_Vec
  valids.PALU(1000,4,PALU_Mat)
  valids.PALU(10**6,4,PALU_Vec)
  """
  from fc_linalg3D.benchs import set_datas
  from fc_linalg3D.random import randn
  from fc_linalg3D import mtimes
  print('Validation LU factorization with partial pivoting')
  A=randn(N,d,d)
  print('   with A a %d-by-%d-by-%d 3D-array'%A.shape)
  P,L,U=fun_PALU(A)
  E=mtimes(P,A)-mtimes(L,U)
  print('Error |P*A-L*U| : %.4e'%np.max(abs(E)))
  
def pLUinplace(N,d,fun_pLUinplace): 
  """
  from fc_linalg3D import valids
  from fc_linalg3D.fact import pLUinplace_Mat,pLUinplace_Vec
  valids.pLUinplace(1000,4,pLUinplace_Mat)
  valids.pLUinplace(10**6,4,pLUinplace_Vec)
  """
  from fc_linalg3D.benchs import set_datas
  from fc_linalg3D.random import randn
  from fc_linalg3D import mtimes
  from fc_linalg3D.fact import LUfrominplace,permInd2Mat
  print('Validation LU factorization with partial pivoting')
  A=randn(N,d,d)
  print('   with A a %d-by-%d-by-%d 3D-array'%A.shape)
  A1=A.copy()
  p1,A1=fun_pLUinplace(A1)
  L1,U1=LUfrominplace(A1)
  P1=permInd2Mat(p1)
  E=mtimes(P1,A)-mtimes(L1,U1)
  print('Error |P*A-L*U| : %.4e'%np.max(abs(E)))  
  
def cholesky(N,d,fun_cholesky):
  """
  from fc_linalg3D import valids
  from fc_linalg3D.fact import cholesky_Mat,cholesky_Vec
  valids.cholesky(1000,4,cholesky_Mat)
  valids.cholesky(10**6,4,cholesky_Vec)
  """
  from fc_linalg3D.random import randnsympd
  from fc_linalg3D import mtimes,ctranspose
  print('Validation Cholesky factorization')
  A=randnsympd(N,d)
  print('   with A a %d-by-%d-by-%d 3D-array'%A.shape)
  B=fun_cholesky(A)
  E=mtimes(B,ctranspose(B))-A
  print('Error |B*B^*-A| : %.4e'%np.max(abs(E)))
  
def det(N,d,fun_det):
  """
  from fc_linalg3D import valids
  from fc_linalg3D.det import det_pLUinplace_Vec,detMix_Vec,det_Nat
  valids.det(1000,4,det_pLUinplace_Vec)
  valids.det(10**6,4,detMix_Vec)
  """
  from fc_linalg3D.random import randnsympd
  print('Validation det function: %s'%fun_det.__name__)
  A=randnsympd(N,d)
  print('   with A a %d-by-%d-by-%d 3D-array'%A.shape)
  D=fun_det(A)
  E=np.max(abs(D-np.linalg.det(A)))
  print('Error : %.4e'%E)
